Subject: Re: bug#41821: 28.0.50; read-directory-name in vc commands should provide defaults from projects

From: Eli Zaretskii <[email-masked]>
Date: Sun, 28 Jun 2020 17:33:36 +0300

> From: Juri Linkov <[email-masked]>
> Cc: Dmitry Gutov <[email-masked]>,  [email-masked]
> Date: Sun, 28 Jun 2020 02:51:06 +0300
> 
> > Why not have some relevant history in VC itself?
> 
> Then like the project history currently is saved in ~/.emacs.d/projects
> saving of a separate vc-directory history will be duplicated the same way
> in e.g. ~/.emacs.d/vc-projects?

Not necessarily duplicated, because no one said the projects I use
will necessarily visit all (indeed, even one of) the VC roots that I
will visit via VC commands.  And vice versa.

IOW, please don't assume that, because project.el can use the VC
backend, it will always use VC in the same directories.  If the roots
are different, offering the same completion candidates will be
confusing and even annoying.

> > Moreover, using a command such as "C-x v d" doesn't mean I want
> > project.el record that, again because I might be using project.el
> > commands for projects that aren't based on VC.
> 
> Then project.el could have a customizable variable that will prevent
> recording vc project history.

What for? let every layer record its own history, and then use the
relevant history in each layer.

> > And if the history is collected by VC, it could be made available to
> > project.el commands that call into VC, right?
> 
> You mean to record an internal vc-history separately from project.el,
> but still to save it in the same project file ~/.emacs.d/projects?

No, I mean provide a possibility for project.el to access the history
saved in ~/.emacs.d/vc-history, in addition to project.el's own
history.  If the user wants that.